/*Hardware registers*/

/*-------- System */

#define INTERRUPT_POLL_CLEAR_REGISTER      0xFFFFFF00
#define INTERRUPT_POLL_CLEAR_REGISTER_H    0xFFFFFF00
#define INTERRUPT_POLL_CLEAR_REGISTER_L    0xFFFFFF02
#define INTERRUPT_MASK_REGISTER            0xFFFFFF04
#define INTERRUPT_MASK_REGISTER_H          0xFFFFFF04
#define INTERRUPT_MASK_REGISTER_L          0xFFFFFF06
#define INTERRUPT_CONTROL_REGISTER         0xFFFFFF08
/*  reserved FFFFFF0A */
#define RANDOM_NUMBER_GENERATOR_REGISTER   0xFFFFFF0C
#define REAL_TIME_CLOCK_I2C_REGISTER       0xFFFFFF0E
/*  reserved FFFFFF10 */
#define TIMER1_CONTROL_REGISTER            0xFFFFFF12
#define TIMER2_CONTROL_REGISTER            0xFFFFFF14
#define TIMER3_CONTROL_REGISTER            0xFFFFFF16
#define PERIPHERAL_CTRL_SPI_DATA_REG       0xFFFFFF18
#define PERIPHERAL_CTRL_SPI_DATA_REG_H     0xFFFFFF18
#define PERIPHERAL_CTRL_SPI_DATA_REG_L     0xFFFFFF1A
#define PERIPHERAL_CTRL_SPI_CONTROL_REG    0xFFFFFF1E
#define SD_CARD_1_DATA_REGISTER            0xFFFFFF20
#define SD_CARD_1_CONTROL_REGISTER         0xFFFFFF22
#define SD_CARD_0_DATA_REGISTER            0xFFFFFF24
#define SD_CARD_0_CONTROL_REGISTER         0xFFFFFF26
#define RHYTM_GENERATOR_K_REGISTER         0xFFFFFF28
#define RHYTM_GENERATOR_K_REGISTER_H       0xFFFFFF28
#define RHYTM_GENERATOR_K_REGISTER_L       0xFFFFFF2A
#define RHYTM_GENERATOR_CONTROL_REGISTER   0xFFFFFF2C
/*  reserved FFFFFF2E */
#define RS232_RX_CONTROL_REGISTER          0xFFFFFF30
#define RS232_RX_DATA_REGISTER             0xFFFFFF31
#define RS232_TX_CONTROL_REGISTER          0xFFFFFF32
#define RS232_TX_DATA_REGISTER             0xFFFFFF33
#define MIDI1_RX_CONTROL_REGISTER          0xFFFFFF34
#define MIDI1_RX_DATA_REGISTER             0xFFFFFF35
#define MIDI2_RX_CONTROL_REGISTER          0xFFFFFF36
#define MIDI2_RX_DATA_REGISTER             0xFFFFFF37
#define MIDI1_TX_CONTROL_REGISTER          0xFFFFFF38
#define MIDI1_TX_DATA_REGISTER             0xFFFFFF39
#define MIDI2_TX_CONTROL_REGISTER          0xFFFFFF3A
#define MIDI2_TX_DATA_REGISTER             0xFFFFFF3B
#define DMX512_TX_CONTROL_REGISTER         0xFFFFFF3C
#define DMX512_TX_DATA_REGISTER            0xFFFFFF3D
/*  reserved FFFFFF3E */

/*-------- Graphics */

#define VRAM_START_ADDRESS                 0xD00000
#define TEST_LED_REGISTER                  0xFFFFFD00  
#define RAMDAC_PALETTE_INDEX_REGISTER      0xFFFFFD06     
#define RAMDAC_PALETTE_RAM_REGISTER        0xFFFFFD04
#define RAMDAC_PIXEL_MASK_REGISTER         0xFFFFFD02

#define GFX_SOURCE_X_REGISTER              0xFFFFFD08
#define GFX_X1_REGISTER                    0xFFFFFD08
#define GFX_SOURCE_Y_REGISTER              0xFFFFFD0A
#define GFX_Y1_REGISTER                    0xFFFFFD0A
#define GFX_DESTINATION_X_REGISTER         0xFFFFFD0C
#define GFX_X2_REGISTER                    0xFFFFFD0C
#define GFX_DESTINATION_Y_REGISTER         0xFFFFFD0E
#define GFX_Y2_REGISTER                    0xFFFFFD0E
#define GFX_LENGTH_REGISTER                0xFFFFFD10
#define GFX_COLOR_REGISTER                 0xFFFFFD12
#define GFX_BIT_MASK_REGISTER              0xFFFFFD14 /*FFFFFD14 and FFFFFD16*/
#define GFX_COMMAND_STATUS_REGISTER        0xFFFFFD28
#define OVERLAY_CROSS_POINTER_X_REG        0xFFFFFD30
#define OVERLAY_CROSS_POINTER_Y_REG        0xFFFFFD32
#define OVERLAY_CROSS_POINTER_CTRL_REG     0xFFFFFD34


