.equ  _PERIPHERAL_CTRL_SPI_DATA_REG,      0xFFFFFF18
.equ  _PERIPHERAL_CTRL_SPI_CONTROL_REG,   0xFFFFFF1E
.equ  _INTERRUPT_MASK_REGISTER_L,         0xFFFFFF06



*---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  _pctrl_IRQ4_handler

_pctrl_IRQ4_handler:
                movem.l %d0-%d1/%a0,-(%sp)
                move.l  _PERIPHERAL_CTRL_SPI_DATA_REG,_evnt_code
                move.b  _evnt_code+0,%d0
                andi.l  #0xF0,%d0
                cmpi.b  #0xD0,%d0
                beq.s   _i4_mouse
                cmpi.b  #0xE0,%d0
                beq.s   _i4_keyboard
                lea     _evnt_buffer,%a0
                move.w  _evb_wr_ptr,%d0
                move.l  _evnt_code,(%a0,%d0.w)
                addq.w  #0x04,%d0
                andi.w  #0x01FC,%d0
                move.w  %d0,_evb_wr_ptr
                bra.s   _i4_exit

_i4_keyboard:   bsr.w   keyboard_IRQ_handler
                bra.s   _i4_exit

_i4_mouse:      nop
*   bsr.w   MOUSE_IRQ_HANDLER


_i4_exit:       movem.l (%sp)+, %d0-%d1/%a0  
                rte
*---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  _pctrl_init

_pctrl_init:    clr.w   _evb_wr_ptr
                clr.w   _evb_rd_ptr
                ori.w   #0x0010, _INTERRUPT_MASK_REGISTER_L
                move.b  #0xC0,_PERIPHERAL_CTRL_SPI_CONTROL_REG
                rts
*---------------------------------------------------------------------------
                .section .data
                .align  2
_evnt_code:     ds.l    1
_evb_wr_ptr:    ds.w    1
_evb_rd_ptr:    ds.w    1
_evnt_buffer:   ds.l    128
*---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  _keyboard_driver_init
                .globl  keyboard_clear_buffer
                .type   keyboard_clear_buffer, @function

_keyboard_driver_init:
                clr.b   _ctrl_pressed
                clr.b   _alt_pressed
keyboard_clear_buffer:
                clr.b   _keybuf_wr_ptr
                clr.b   _keybuf_rd_ptr
                rts
*---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  key_pressed
                .type   key_pressed, @function
key_pressed:
                clr.l   %d0
                move.b  _keybuf_wr_ptr,%d0
                cmp.b   _keybuf_rd_ptr,%d0
                sne     %d0
                rts
*---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  get_key
                .type   get_key, @function
get_key:
                clr.w   %d6
                clr.l   %d0
                move.b  _keybuf_rd_ptr,%d6
                cmp.b   _keybuf_wr_ptr,%d6
                beq.s   _gk_exit
                lea     _keybuf,%a0
                move.b  (%a0,%d6.w),%d0
                addq.b  #0x01,%d6
                andi.b  #0x3F,%d6
                move.b  %d6,_keybuf_rd_ptr
_gk_exit:       rts
*---------------------------------------------------------------------------
                .section .text
                .align  2
keyboard_IRQ_handler:

                lea     _keybuf,%a0
                clr.l   %d0
                move.b  _keybuf_wr_ptr,%d0
                move.b  _evnt_code+3,(%a0,%d0.w)
                addq.b  #0x01,%d0
                andi.b  #0x3F,%d0
                move.b  %d0,_keybuf_wr_ptr
                move.b  _evnt_code+3,%d0

     *test for CTRL pressed
                cmpi.b  #0x01,%d0 
                beq.s   _kbi_C3
                cmpi.b  #0x04,%d0
                bne.s   _kbi_C4
_kbi_C3:        move.b  %d0,_ctrl_pressed
                bra.s   _kbi_P0
_kbi_C4:

     *test for CTRL released
                cmpi.b  #0x81,%d0
                beq.s   _kbi_C5
                cmpi.b  #0x84,%d0
                bne.s   _kbi_C6
_kbi_C5:        clr.b   _ctrl_pressed
                bra.s   _kbi_P0
_kbi_C6:

     *test for ALT pressed
                cmpi.b  #0x03,%d0
                beq.s   _kbi_A3
                cmpi.b  #0x06,%d0
                bne.s   _kbi_A4
_kbi_A3:        move.b  %d0,_alt_pressed
                bra.s   _kbi_P0
_kbi_A4:

     *test for ALT released
                cmpi.b  #0x83,%d0
                beq.s   _kbi_A5
                cmpi.b  #0x86,%d0
                bne.s   _kbi_A6
_kbi_A5:        clr.b   _alt_pressed
                bra.s   _kbi_P0
_kbi_A6:

     *test for DEL pressed
                cmpi.b  #0x22,%d0
                bne.s   _kbi_P0
                tst.b   _ctrl_pressed
                beq.s   _kbi_P0
                tst.b   _alt_pressed
                beq.s   _kbi_P0

     *ctrl_alt_del pressed!

                jmp     SYS_restart

_kbi_P0:        rts

*---------------------------------------------------------------------------
               .section .data
_keybuf_wr_ptr: ds.b    1
_keybuf_rd_ptr: ds.b    1
_keybuf:        ds.b    64
_ctrl_pressed:  ds.b    1
_alt_pressed:   ds.b    1
                .align  2
