*----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  _sys_reset_entry
_sys_reset_entry:
                pea     0
                bsr.w   GFX_load_LED_register
                addq.l  #0x04,%sp
                bsr.w   _pctrl_init
                bsr.w   _keyboard_driver_init
                move.l  #0x1A7F6CB3,_rnd32_tmp
                jsr     main
                bra.w   SYS_restart

*----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  SYS_enable_interrupts
                .type   SYS_enable_interrupts, @function
SYS_enable_interrupts:
                move    #0x2500,%sr
                rts

*----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  SYS_disable_interrupts
                .type   SYS_disable_interrupts, @function
SYS_disable_interrupts:
                move    #0x2700,%sr
                rts

*----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  SYS_restart
                .type   SYS_restart, @function
SYS_restart:
                move    #0x2700,%sr
                move.l  (0),%sp
                move.l  (4),%a0
                jmp     (%a0)



*----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  SYS_init_rnd32
                .type   SYS_init_rnd32, @function

SYS_init_rnd32:
                move.l  4(%sp),_rnd32_tmp
                rts

*----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  SYS_rnd32
                .type   SYS_rnd32, @function

SYS_rnd32:
                move.l  _rnd32_tmp,%d0
                rol.l   #1,%d0
                move.w  %d0,%d1
                swap    %d0
                asl.w   #1,%d1
                addq.w  #0x3,%d0
                add.w   %d1,%d0
                move.l  %d0,_rnd32_tmp
                rts

_rnd32_tmp:     ds.l    1
*----------------------------------------------------------------------------






